



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>利用MySQL 的GROUP_CONCAT函数实现聚合乘法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">利用MySQL 的GROUP_CONCAT函数实现聚合乘法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-25 22:25:20 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
MySQL 聚合函数里面提供了加，平均数。最小，最大等，可是没有提供乘法，我们这里来利用MYSQL现有的GROUP_CONCAT函数实现聚合乘法。</p>
<p>先创建一张演示样例表：
<pre class="prettyprint linenums">CREATE TABLE `tb_seq` (<br />
  `num` int(10) NOT NULL,<br />
  `seq_type` enum('yellow','green','red') NOT NULL<br />
) ENGINE=InnoDB DEFAULT CHARSET=utf8;
</pre>
<p>插入演示样例数据：
<pre class="prettyprint linenums">insert  into `tb_seq`(`num`,`seq_type`)<br />
values (4,'green'),(1,'red'),(3,'green'),<br />
	    (1,'red'),(8,'red'),(4,'yellow'),<br />
	    (8,'red'),(7,'yellow'),(10,'red'),<br />
	    (1,'red'),(1,'red'),(1,'yellow'),<br />
	    (5,'green'),(9,'red'),(1,'yellow'),<br />
	    (6,'yellow');</pre>
<p>创建基于逗号分隔符的字符串乘法，前提是字符串逗号分隔的都是数字。
<pre class="prettyprint linenums">DELIMITER $$

USE `t_girl`$$

DROP FUNCTION IF EXISTS `func_multiple`$$

CREATE DEFINER=`root`@`localhost` FUNCTION `func_multiple`(<br />
    f_nums VARCHAR(1000)<br />
    ) RETURNS DOUBLE(10,2)<br />
BEGIN<br />
      -- Created by ytt 2014/10/21.<br />
      DECLARE result DOUBLE(10,2) DEFAULT 1;<br />
      DECLARE cnt,i INT DEFAULT 0;

      SET cnt = CHAR_LENGTH(f_nums) - CHAR_LENGTH(REPLACE(f_nums,',','')) + 1;

      WHILE i &lt; cnt<br />
      DO<br />
        -- get multiple result.<br />
        SET result = result * REVERSE(SUBSTRING_INDEX(REVERSE(SUBSTRING_INDEX(f_nums,',',i+1)),',',1));<br />
        SET i = i + 1;<br />
      END WHILE;<br />
      SET result = ROUND(result,2);<br />
      RETURN result;

    END$$

DELIMITER ;</pre>
<p>好了。我们利用我创建的函数以及MYSQL自带的GROUP_CONCAT聚合函数就能够非常方便的实现乘法了。</p>
<p><pre class="prettyprint linenums">SELECT seq_type,func_multiple(GROUP_CONCAT(num ORDER BY num ASC SEPARATOR ',')) AS multiple_num FROM tb_seq WHERE 1 GROUP BY seq_type;

+----------+--------------+<br />
| seq_type | multiple_num |<br />
+----------+--------------+<br />
| yellow   |       168.00 |<br />
| green    |        60.00 |<br />
| red      |      5760.00 |<br />
+----------+--------------+<br />
3 rows in set (0.00 sec)</pre></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4120qz.html">c 进程和系统调用</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ov7p5q.html">统计图表类型选择应用总结&amp;amp&semi;表数据挖掘方法及应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mzrp2q.html">UOJ265 【NOIP2016】愤怒的小鸟</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900mz39.html">php  复习</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxgn2e9.html">Maven构建简单的多模块项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r2y3mq.html">在&period;net桌面程序中自定义鼠标光标</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv24djq.html">Android-ImageView&period;ScaleType</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwp0n8.html">A - A</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzppzw8.html">hadoop使用笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjnkek8.html">hibernate  一对多 多对一 关系表 增删改查大礼包ps二级查也有</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd7gxz9.html">为什么会需要消息队列&lpar;MQ&rpar;？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwwgj9.html">&period;Net Core 1&period;0升级2&period;0（xproj项目迁移到&period;csproj ）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1xdljq.html">Python&mdash;&mdash;正则模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2e6x6q.html">JVM、垃圾收集器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwg6v48.html">2014西安赛区C题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r67e48.html">Jmeter在Linux下执行</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gppz0z9.html">半个月使用rust语言的体验</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwln7kz9.html">c&plus;&plus;&mdash;&mdash; 函数重载（Overroad）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1pvg09.html">JTree实现电脑资源管理器</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1dlox9.html">java获取当月的第一天和最后一天&comma;获取本周的第一天和最后一天</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4yee13q.html">Python type类具体的三大分类&colon;metaclasses&comma;classes&comma;instance</a>
			</li>
						<li><a href="https://www.batexi.com/a/950rrn68.html">hdoj 3478 Catch&lpar;二分图判定&plus;并查集&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzjz4l8.html">PeopleEditor的取值及赋值</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pj0nj8.html">&lbrack;译&rsqb;Stairway to Integration Services Level 13 - SSIS 变量回顾</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlje13k9.html">C&plus;&plus;日期和时间</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zxey19.html">Mini-project &num; 1 - Rock-paper-scissors-&lowbar;&lowbar;&lowbar;An Introduction to Interactive Programming in Python&amp;quot&semi;RICE&amp;quot&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjmn7g8.html">杭电ACM  偶数求和</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp0mr59.html">easyui-datagrid通过action从数据库获取数据的关键代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zx73j9.html">select into from 和 insert into select 的用法和区别&lpar;转&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdnk349.html">&lbrack;LeetCode&rsqb;题解（python）：028-Implement strStr&lpar;&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
